from _typeshed import Incomplete
from firebase_admin import _auth_utils

MAX_LIST_CONFIGS_RESULTS: int

class ProviderConfig:
    def __init__(self, data) -> None: ...
    @property
    def provider_id(self): ...
    @property
    def display_name(self): ...
    @property
    def enabled(self): ...

class OIDCProviderConfig(ProviderConfig):
    @property
    def issuer(self): ...
    @property
    def client_id(self): ...
    @property
    def client_secret(self): ...
    @property
    def id_token_response_type(self): ...
    @property
    def code_response_type(self): ...

class SAMLProviderConfig(ProviderConfig):
    @property
    def idp_entity_id(self): ...
    @property
    def sso_url(self): ...
    @property
    def x509_certificates(self): ...
    @property
    def callback_url(self): ...
    @property
    def rp_entity_id(self): ...

class ListProviderConfigsPage:
    def __init__(self, download, page_token, max_results) -> None: ...
    @property
    def provider_configs(self) -> None: ...
    @property
    def next_page_token(self): ...
    @property
    def has_next_page(self): ...
    def get_next_page(self): ...
    def iterate_all(self): ...

class _ListOIDCProviderConfigsPage(ListProviderConfigsPage):
    @property
    def provider_configs(self): ...

class _ListSAMLProviderConfigsPage(ListProviderConfigsPage):
    @property
    def provider_configs(self): ...

class _ProviderConfigIterator(_auth_utils.PageIterator):
    @property
    def items(self): ...

class ProviderConfigClient:
    PROVIDER_CONFIG_URL: str
    http_client: Incomplete
    base_url: Incomplete
    def __init__(self, http_client, project_id, tenant_id: Incomplete | None = None, url_override: Incomplete | None = None) -> None: ...
    def get_oidc_provider_config(self, provider_id): ...
    def create_oidc_provider_config(self, provider_id, client_id, issuer, display_name: Incomplete | None = None, enabled: Incomplete | None = None, client_secret: Incomplete | None = None, id_token_response_type: Incomplete | None = None, code_response_type: Incomplete | None = None): ...
    def update_oidc_provider_config(self, provider_id, client_id: Incomplete | None = None, issuer: Incomplete | None = None, display_name: Incomplete | None = None, enabled: Incomplete | None = None, client_secret: Incomplete | None = None, id_token_response_type: Incomplete | None = None, code_response_type: Incomplete | None = None): ...
    def delete_oidc_provider_config(self, provider_id) -> None: ...
    def list_oidc_provider_configs(self, page_token: Incomplete | None = None, max_results=...): ...
    def get_saml_provider_config(self, provider_id): ...
    def create_saml_provider_config(self, provider_id, idp_entity_id, sso_url, x509_certificates, rp_entity_id, callback_url, display_name: Incomplete | None = None, enabled: Incomplete | None = None): ...
    def update_saml_provider_config(self, provider_id, idp_entity_id: Incomplete | None = None, sso_url: Incomplete | None = None, x509_certificates: Incomplete | None = None, rp_entity_id: Incomplete | None = None, callback_url: Incomplete | None = None, display_name: Incomplete | None = None, enabled: Incomplete | None = None): ...
    def delete_saml_provider_config(self, provider_id) -> None: ...
    def list_saml_provider_configs(self, page_token: Incomplete | None = None, max_results=...): ...
