from _typeshed import Incomplete
from google.auth.credentials import Credentials as GoogleAuthCredentials
from typing import NamedTuple

class AccessTokenInfo(NamedTuple):
    access_token: Incomplete
    expiry: Incomplete

class Base:
    def get_access_token(self): ...
    def get_credential(self) -> None: ...

class _ExternalCredentials(Base):
    def __init__(self, credential: GoogleAuthCredentials) -> None: ...
    def get_credential(self): ...

class Certificate(Base):
    def __init__(self, cert) -> None: ...
    @property
    def project_id(self): ...
    @property
    def signer(self): ...
    @property
    def service_account_email(self): ...
    def get_credential(self): ...

class ApplicationDefault(Base):
    def __init__(self) -> None: ...
    def get_credential(self): ...
    @property
    def project_id(self): ...

class RefreshToken(Base):
    def __init__(self, refresh_token) -> None: ...
    @property
    def client_id(self): ...
    @property
    def client_secret(self): ...
    @property
    def refresh_token(self): ...
    def get_credential(self): ...
