from _typeshed import Incomplete
from firebase_admin import exceptions as exceptions

def android_app(app_id, app: Incomplete | None = None): ...
def ios_app(app_id, app: Incomplete | None = None): ...
def list_android_apps(app: Incomplete | None = None): ...
def list_ios_apps(app: Incomplete | None = None): ...
def create_android_app(package_name, display_name: Incomplete | None = None, app: Incomplete | None = None): ...
def create_ios_app(bundle_id, display_name: Incomplete | None = None, app: Incomplete | None = None): ...

class AndroidApp:
    def __init__(self, app_id, service) -> None: ...
    @property
    def app_id(self): ...
    def get_metadata(self): ...
    def set_display_name(self, new_display_name): ...
    def get_config(self): ...
    def get_sha_certificates(self): ...
    def add_sha_certificate(self, certificate_to_add): ...
    def delete_sha_certificate(self, certificate_to_delete): ...

class IOSApp:
    def __init__(self, app_id, service) -> None: ...
    @property
    def app_id(self): ...
    def get_metadata(self): ...
    def set_display_name(self, new_display_name): ...
    def get_config(self): ...

class _AppMetadata:
    def __init__(self, name, app_id, display_name, project_id) -> None: ...
    @property
    def app_id(self): ...
    @property
    def display_name(self): ...
    @property
    def project_id(self): ...
    def __eq__(self, other): ...

class AndroidAppMetadata(_AppMetadata):
    def __init__(self, package_name, name, app_id, display_name, project_id) -> None: ...
    @property
    def package_name(self): ...
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    def __hash__(self): ...

class IOSAppMetadata(_AppMetadata):
    def __init__(self, bundle_id, name, app_id, display_name, project_id) -> None: ...
    @property
    def bundle_id(self): ...
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    def __hash__(self): ...

class SHACertificate:
    SHA_1: str
    SHA_256: str
    def __init__(self, sha_hash, name: Incomplete | None = None) -> None: ...
    @property
    def name(self): ...
    @property
    def sha_hash(self): ...
    @property
    def cert_type(self): ...
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    def __hash__(self): ...

class _ProjectManagementService:
    BASE_URL: str
    MAXIMUM_LIST_APPS_PAGE_SIZE: int
    MAXIMUM_POLLING_ATTEMPTS: int
    POLL_BASE_WAIT_TIME_SECONDS: float
    POLL_EXPONENTIAL_BACKOFF_FACTOR: float
    ANDROID_APPS_RESOURCE_NAME: str
    ANDROID_APP_IDENTIFIER_NAME: str
    IOS_APPS_RESOURCE_NAME: str
    IOS_APP_IDENTIFIER_NAME: str
    def __init__(self, app) -> None: ...
    def get_android_app_metadata(self, app_id): ...
    def get_ios_app_metadata(self, app_id): ...
    def set_android_app_display_name(self, app_id, new_display_name) -> None: ...
    def set_ios_app_display_name(self, app_id, new_display_name) -> None: ...
    def list_android_apps(self): ...
    def list_ios_apps(self): ...
    def create_android_app(self, package_name, display_name: Incomplete | None = None): ...
    def create_ios_app(self, bundle_id, display_name: Incomplete | None = None): ...
    def get_android_app_config(self, app_id): ...
    def get_ios_app_config(self, app_id): ...
    def get_sha_certificates(self, app_id): ...
    def add_sha_certificate(self, app_id, certificate_to_add) -> None: ...
    def delete_sha_certificate(self, certificate_to_delete) -> None: ...
